/*
 * UCB-BF504 CPLB/LbVݒTv
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * ̃TvR[hɂẮALURLQƂB
 * http://kaneko-sys.co.jp/support/
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

/*
 * yz
 * ̃vÓACPLB̐ݒƁACXgNVyуf[^LbV
 * ݒs܂BtbVɃvOf[^zuꍇ́A
 * ptH[}X̂߂ɃLbV̐ݒsĂB
 *
 * Visual DSP++̏ꍇAvWFNg̃IvVƃÑ}Nݒ肷
 * Kv܂Bڂ́AJXNvg ADSP-BF504F.ldfQƂB
 * USE_INSTRUCTION_CACHE, USE_DATA_A_CACHE, USE_DATA_B_CACHE, USE_CACHE
 */

#include <blackfin.h>
#include <builtins.h>
#include <stdint.h>
#include <string.h>

/* RANbN(400MHz) */
#define CCLOCK_HZ		(400000000)
/* VXeNbN(100MHz) */
#define SCLOCK_HZ		(100000000)

struct cplb_segment
{
	uint32_t addr;
	uint32_t data;
};

/* ICPLB̐ݒ */
static const struct cplb_segment sf_icplb_memory_list[] =
{
	/* ICPLB_ADDRx, ICPLB_DATAx ̏ */
	/* L1 INSTRUCTION SRAM */
	{0xFFA00000, PAGE_SIZE_1MB | CPLB_LOCK | CPLB_USER_RD | CPLB_VALID},	/* L1 INSTRUCTION SRAM̓LbVOFF */
	/* SYNC FLASH MEMORY */
	{0x20000000, PAGE_SIZE_1MB | CPLB_L1_CHBL | CPLB_USER_RD | CPLB_VALID},	/* tbV̓LbVON */
};

/* DCPLB̐ݒ */
static const struct cplb_segment sf_dcplb_memory_list[] =
{
	/* DCPLB_ADDRx, DCPLB_DATAx ̏ */
	/* L1 SCRATCHPAD RAM */
	{0xFFB00000, PAGE_SIZE_4KB | CPLB_LOCK | CPLB_SUPV_WR | CPLB_USER_RD | CPLB_USER_WR | CPLB_VALID},	/* L1 SCRATCHPAD RAM̓LbVOFF */
	/* L1 DATA BANK A/B SRAM */
	{0xFF800000, PAGE_SIZE_1MB | CPLB_LOCK | CPLB_SUPV_WR | CPLB_USER_RD | CPLB_USER_WR | CPLB_VALID},	/* L1 DATA SRAM̓LbVOFF */
	/* SYNC FLASH MEMORY (READ ONLY) */
	{0x20000000, PAGE_SIZE_1MB | CPLB_L1_CHBL | CPLB_WT | CPLB_USER_RD | CPLB_VALID},	/* tbV̓LbVON */
};

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

static void s_bfin_cplb_init(void)
{
	int32_t   l_lc;
	uint32_t* lp_cplb_addr;

    /* Disable DCPLB */
    *pDMEM_CONTROL = 0;
    /* Disabel ICPLB */
    *pIMEM_CONTROL = 0;
    ssync();

	/* ICPLB_ADDRx/ICPLB_DATAxWX^ */
    lp_cplb_addr = (uint32_t*)ICPLB_ADDR0;
	for(l_lc = 0; l_lc < (sizeof(sf_icplb_memory_list) / sizeof(struct cplb_segment)); l_lc++)
	{
		lp_cplb_addr[l_lc] = sf_icplb_memory_list[l_lc].addr;
		pICPLB_DATA0[l_lc] = sf_icplb_memory_list[l_lc].data;
	}

	/* DCPLB_ADDRx/DCPLB_DATAxWX^ */
    lp_cplb_addr = (uint32_t*)DCPLB_ADDR0;
	for(l_lc = 0; l_lc < (sizeof(sf_dcplb_memory_list) / sizeof(struct cplb_segment)); l_lc++)
	{
		lp_cplb_addr[l_lc] = sf_dcplb_memory_list[l_lc].addr;
		pDCPLB_DATA0[l_lc] = sf_dcplb_memory_list[l_lc].data;
	}

    /* Enable ICPLB */
	*pIMEM_CONTROL = IMC | ENICPLB | 1;	/* (1 = bit0) */
    /* Enable DCPLB */
	*pDMEM_CONTROL = 0x8 | ENDCPLB | 1;	/* (1 = bit0) */
    ssync();
}

section("FLASH_data")
static const uint8_t sf_flash_constdata[1024];

static uint8_t sf_l1sram_data[1024];

void main(void)
{
	/* PLLݒ */
	s_bfin_clk_pll_set(16, 4);
	/* CPLB̐ݒALbVON */
	s_bfin_cplb_init();
	
	/* eXgp_~[Rs[ */
	memcpy(sf_l1sram_data, sf_flash_constdata, sizeof(sf_l1sram_data));
}
